﻿using UnityEngine;
using System.Collections;

public class Player : MonoBehaviour {

    public int life = 5;

    // configuração movimento
    public float gravity;
    public float runSpeed;
    public float jumpHeight;


    public AudioClip jumpClip;// som para o pulo
    public AudioClip walkClip;// som para a caminhada

    private float normalizedHorizontalSpeed = 0;

    [HideInInspector]
    public CharacterController2D _controller;

    private Animator _animator;
    private Vector3 _velocity;

    [HideInInspector]
    public bool dash;

    [HideInInspector]
    public float deshTime;

    public bool death;

    private bool isClimbing = false;
    private float friction;



    public KeyCode KeyJump;
    //public KeyCode KeyUp;
    //public KeyCode keyDow;
    public KeyCode keyLeft;
    public KeyCode keyRight;

    //-------------------

    void Start()
    {
        _animator = gameObject.GetComponent<Animator>();
        _controller = GetComponent<CharacterController2D>();

    }


    void OnTriggerEnter2D(Collider2D other)
    {
        //if (other.tag == "Enemy")
        //{
        //    death = true;
        //    _animator.SetBool("Death", true);
        //    //  this.gameObject.GetComponent<Player>().enabled = false;
        //}
    }

    void OnTriggerStay2D(Collider2D other)
    {
        //if (other.tag == "Bag" && armed == false && _controller.isGrounded && Input.GetKeyDown(KeyCode.UpArrow))
        //{
        //    armed = true;
        //}

        //if (other.tag == "RaioTrator")
        //{
        //    _animator.Play("Abducted_A");
        //}
    }

    void OnCollisionEnter2D(Collision2D coll)
    {
        if (coll.gameObject.tag == "Bullet")
        {
         //  gameObject.rigidbody2D.AddForce(new Vector2(coll.transform.localScale.x * runSpeed, 0));
            _animator.SetTrigger("Injured");

            if (life > 0)
            {
                life--;
            }

            if (life <= 0)
            {
                death = true;
            }
        }
    }




    void Update()
    {

        _velocity = _controller.velocity;

        Direction();
        Jump();

        UpdateMoviment();


        //===================================================================================================================
        _animator.SetBool("Ground", _controller.isGrounded);

        _animator.SetBool("Walk", _controller.isGrounded && normalizedHorizontalSpeed != 0);

        _animator.SetBool("Falling", !_controller.isGrounded && _controller.isFalling);

        _animator.SetBool("Death", death);
    }

    void walkP()//son dos passos
    {
        AudioSource.PlayClipAtPoint(walkClip, transform.position);
    }


    public void UpdateMoviment()
    {

            if (!_controller.isGrounded && _controller.isCanClimb && _controller.isFalling)
            {
                _velocity.y += gravity / 4 * Time.deltaTime;
            }
            else
            {
                _velocity.y += gravity * Time.deltaTime;
            }

        _velocity.x = Mathf.Lerp(_velocity.x, normalizedHorizontalSpeed * runSpeed, Time.deltaTime);

        _controller.move(_velocity * Time.deltaTime);
    }


    public void Direction()
    {


        if (Input.GetKey(keyRight) && !death)
        {
            _velocity.x = 0;
            normalizedHorizontalSpeed = 1;
            if (transform.localScale.x < 0f)
                transform.localScale = new Vector3(-transform.localScale.x, transform.localScale.y, transform.localScale.z);

        }
        else
            if (Input.GetKey(keyLeft) && !death)
            {
                _velocity.x = 0;
                normalizedHorizontalSpeed = -1;
                if (transform.localScale.x > 0f)
                    transform.localScale = new Vector3(-transform.localScale.x, transform.localScale.y, transform.localScale.z);
            }
            else
            {
                normalizedHorizontalSpeed = 0;
                _velocity.x = 0;
            }

    }


    void Jump()
    {
        if (_controller.isGrounded && Input.GetKeyDown(KeyJump) && !death)
        {
            _velocity.y = Mathf.Sqrt(jumpHeight * -gravity);

            gameObject.transform.parent = null;

            if (jumpClip != null)
            {
                AudioSource.PlayClipAtPoint(jumpClip, transform.position);
            }
        }

    }

    private void DrawRay(Vector3 start, Vector3 dir, Color color)
    {
        Debug.DrawRay(start, dir, color);
    }


}
