﻿using UnityEngine;
using System.Collections;

[RequireComponent(typeof(SpriteRenderer))]
[RequireComponent(typeof(Rigidbody2D), typeof(BoxCollider2D), typeof(AudioSource))]
public class Bullet : MonoBehaviour
{
    private GameObject player;

    public float speed;
    public AudioClip bulletSound;

    public float dissipationTime=3;
    private float time;

    private AudioSource _audio;
    private SpriteRenderer _spriteRender;

    public GameObject explosion;

    private Vector3 dir;

    void Start()
    {
       

        if (bulletSound != null)
        {
            _audio = GetComponent<AudioSource>();
            _audio.clip = bulletSound;
            //volume principal dos efeitos
            _audio.volume = GameConfig.effectVolume;
            _audio.Play();
        }

        _spriteRender = GetComponent<SpriteRenderer>();

    }

    

    void Update()
    {
        time+=Time.deltaTime;
 
        if(time>=dissipationTime)
        {
            GameObject.Destroy(this.gameObject);
        }


        //deslocamento do projetil
        
        transform.Translate(dir * speed);
       // transform.Translate(new Vector2( speed,0));
    }


    public void SetPlayer(GameObject p)
    {
        player = p;
        dir = Vector2.right * player.transform.localScale.x;
        transform.localScale = player.transform.localScale;
    }

    void OnCollisionEnter2D(Collision2D coll)
    {
        if (coll.gameObject.name != player.name)
        {

            if (explosion != null)
            {
                GameObject e = (GameObject)Instantiate(explosion, transform.position, transform.rotation);
                e.transform.localScale = gameObject.transform.localScale;
            }
            Destroy(gameObject);
        }
    }


  }
   
  