﻿using UnityEngine;

[ExecuteInEditMode]
public class PixelPerfectCamera : MonoBehaviour
{
    private Camera _camera;

    public int GameTargetHeight = 720;

    public float pixelsToUnits = 300;


    protected void Start()
    {
        _camera = this.gameObject.GetComponent<Camera>();

        if (!_camera)
        {
            Debug.LogWarning("No camera for pixel perfect cam to use");
        }
        else
        {
            _camera.orthographic = true;
        }
    }


	void Update() {

        _camera.orthographicSize = (GameTargetHeight / 2) / pixelsToUnits;
	}
}
